import {EntityRepository, Repository} from "typeorm";
import {CareerDetailsPageCmsEntity} from "./entities/career-details-page-cms.entity";
import {UpdateCareerDetailsPageCmsDto} from "./dto/update-career-details-page-cms.dto";

@EntityRepository(CareerDetailsPageCmsEntity)
export class CareerDetailsPageCmsRepository extends Repository<CareerDetailsPageCmsEntity> {

    async createEntity(dto: UpdateCareerDetailsPageCmsDto): Promise<CareerDetailsPageCmsEntity | Error> {
        try {
            const entity = this.create({
                needHelpContext: dto.needHelpContext,
                email: dto.email,
                contactNo: dto.contactNo
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateCareerDetailsPageCmsDto, id: string): Promise<CareerDetailsPageCmsEntity | Error> {
        try {
            await this.update(id, {
                needHelpContext: dto.needHelpContext,
                email: dto.email,
                contactNo: dto.contactNo
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<CareerDetailsPageCmsEntity[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}