import {EntityRepository, Repository} from "typeorm";
import {EasyPaymentSectionCmsEntity} from "./entities/easy-payment-section-cms.entity";
import {UpdateEasyPaymentSectionCmsDto} from "./dto/update-easy-payment-section-cms.dto";

@EntityRepository(EasyPaymentSectionCmsEntity)
export class EasyPaymentSectionCmsRepository extends Repository<EasyPaymentSectionCmsEntity> {

    async createEntity(dto: UpdateEasyPaymentSectionCmsDto): Promise<EasyPaymentSectionCmsEntity | Error> {
        try {
            const entity = this.create({
                title: dto.title,
                sectionTitle: dto.sectionTitle,
                sectionSubTitle: dto.sectionSubTitle
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateEasyPaymentSectionCmsDto, id: string): Promise<EasyPaymentSectionCmsEntity | Error> {
        try {
            await this.update(id, {
                title: dto.title,
                sectionTitle: dto.sectionTitle,
                sectionSubTitle: dto.sectionSubTitle
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<EasyPaymentSectionCmsEntity[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}