import {EntityRepository, getConnection, Repository} from "typeorm";
import {UpdatePressAboutContentCmsDto} from "./dto/update-press-about-content-cms.dto";
import {PressAboutContentCmsEntity} from "./entity/press-about-content-cms.entity";

@EntityRepository(PressAboutContentCmsEntity)
export class PressAboutContentCmsRepository extends Repository<PressAboutContentCmsEntity> {

    async createEntity(dto: UpdatePressAboutContentCmsDto): Promise<PressAboutContentCmsEntity | Error> {
        try {
            const {
                description
            } = dto;
            const entity = this.create({
                description
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async findByFilterQuery(query: any): Promise<PressAboutContentCmsEntity[] | Error> {
        try {
            return await this.find({
                where: {...query, isDeleted: false}
            });
        } catch (e) {
            return e;
        }
    }

    async findOneEntity(id: string): Promise<PressAboutContentCmsEntity | Error> {
        try {
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async updateEntity(id: string, dto: UpdatePressAboutContentCmsDto): Promise<PressAboutContentCmsEntity | Error> {
        try {
            await this.update(id, dto);
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async deleteEntity(id: string): Promise<boolean | Error> {
        try {
            const updateResult = await getConnection()
                .createQueryBuilder()
                .update(PressAboutContentCmsEntity)
                .set({isDeleted: true})
                .where("id = :id", {id: id})
                .execute();
            if (updateResult.affected > 0) {
                return true;
            }
            return false;
        } catch (e) {
            return e;
        }
    }
}