import {EntityRepository, Repository} from "typeorm";
import {PressKitPageCmsEntity} from "./entities/press-kit-page-cms.entity";
import {UpdatePressKitPageCmsDto} from "./dto/update-press-kit-page-cms.dto";

@EntityRepository(PressKitPageCmsEntity)
export class PressKitPageCmsRepository extends Repository<PressKitPageCmsEntity> {

    async createEntity(dto: UpdatePressKitPageCmsDto): Promise<PressKitPageCmsEntity | Error> {
        try {
            const entity = this.create({
                aboutIcon: dto.aboutIcon,
                linkIcon: dto.linkIcon,
                pressCoverageIcon: dto.pressCoverageIcon,
                pressCoverageTitle: dto.pressCoverageTitle
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdatePressKitPageCmsDto, id: string): Promise<PressKitPageCmsEntity | Error> {
        try {
            await this.update(id, {
                aboutIcon: dto.aboutIcon,
                linkIcon: dto.linkIcon,
                pressCoverageIcon: dto.pressCoverageIcon,
                pressCoverageTitle: dto.pressCoverageTitle
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<PressKitPageCmsEntity[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}