import {EntityRepository, Repository} from "typeorm";
import {UpdateWhatsNextSectionCmsDto} from "./dto/update-whats-next-section-cms.dto";
import {WhatsNextSectionCmsEntity} from "./entities/whats-next-section-cms.entity";

@EntityRepository(WhatsNextSectionCmsEntity)
export class WhatsNextSectionCmsRepository extends Repository<WhatsNextSectionCmsEntity> {

    async createEntity(dto: UpdateWhatsNextSectionCmsDto): Promise<WhatsNextSectionCmsEntity | Error> {
        try {
            const entity = this.create({
                sectionOneImage: dto.sectionOneImage,
                sectionOnetitle: dto.sectionOnetitle,
                sectionOneSubtitle: dto.sectionOneSubtitle,
                sectionOneDescription: dto.sectionOneDescription,
                sectionOneButtonText: dto.sectionOneButtonText,
                sectionOneButtonLink: dto.sectionOneButtonLink,
                sectionTwoImage: dto.sectionTwoImage,
                sectionTwotitle: dto.sectionTwotitle,
                sectionTwoSubtitle: dto.sectionTwoSubtitle,
                sectionTwoDescription: dto.sectionTwoDescription,
                sectionTwoButtonText: dto.sectionTwoButtonText,
                sectionTwoButtonLink: dto.sectionTwoButtonLink
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateWhatsNextSectionCmsDto, id: string): Promise<WhatsNextSectionCmsEntity | Error> {
        try {
            await this.update(id, {
                sectionOneImage: dto.sectionOneImage,
                sectionOnetitle: dto.sectionOnetitle,
                sectionOneSubtitle: dto.sectionOneSubtitle,
                sectionOneDescription: dto.sectionOneDescription,
                sectionOneButtonText: dto.sectionOneButtonText,
                sectionOneButtonLink: dto.sectionOneButtonLink,
                sectionTwoImage: dto.sectionTwoImage,
                sectionTwotitle: dto.sectionTwotitle,
                sectionTwoSubtitle: dto.sectionTwoSubtitle,
                sectionTwoDescription: dto.sectionTwoDescription,
                sectionTwoButtonText: dto.sectionTwoButtonText,
                sectionTwoButtonLink: dto.sectionTwoButtonLink
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<WhatsNextSectionCmsEntity[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}