import { Injectable } from "@nestjs/common";
// import sharp from 'sharp';
import { ImageUtils } from "../../utils/image.utils";
import { UpdateFileUploadDto } from "./dto/update-file-upload.dto";
import * as fs from 'fs-extra';
import { extname } from "path";
import {v4 as uuidv4} from "uuid";

@Injectable()
export class FileUploadsService {
    async saveFile(file: Express.Multer.File, sizes: number[]): Promise<string> {
        if (sizes.length === 0) {
            const data = await ImageUtils.defualtSize(file);
            console.log("data 2= ", data);

            return data;
        } else {
            const data = await ImageUtils.resize(file, sizes[0], sizes[1]);

            return data;
        }

        // return ResponseUtils.buildData(
        //     data
        // );
    }

    async saveFiles(file: Express.Multer.File, sizes: number[]): Promise<string> {
        if (sizes.length == 0) {
            const data = await ImageUtils.defualtSize(file);
            console.log("data 2= ", data);

            return data;
        } else {
            const data = await ImageUtils.resize(file, sizes[0], sizes[1]);

            return data;
        }

        // return ResponseUtils.buildData(
        //     data
        // );
    }

    findAll() {
        return `This action returns all fileUploads`;
    }

    findOne(id: number) {
        return `This action returns a #${id} fileUpload`;
    }

    update(id: number, updateFileUploadDto: UpdateFileUploadDto) {
        return `This action updates a #${id} fileUpload`;
    }

    remove(id: number) {
        return `This action removes a #${id} fileUpload`;
    }

    async saveFileToUploadsFolder(buffer: Buffer, fileName: string, rootPath: string, uploadPath: string): Promise<string> {
        try {
            const extension = extname(fileName);
            const newFileName = `transaction.${uuidv4()}${extension}`;

            // Ensure the uploads folder exists, create it if not
            await fs.ensureDir(uploadPath);

            // Define the full path to save the file
            const filePath = `${rootPath}/${uploadPath}/${newFileName}`;

            // Write the buffer to the file
            await fs.writeFile(filePath, buffer);

            // Return the file path where it was saved
            return `${uploadPath}/${newFileName}`;
        } catch (error) {
            throw new Error(`Could not save file: ${error.message}`);
        }
    }
}
