import {Module} from '@nestjs/common';
import {MessageService} from './message.service';
import {MessageGateway} from './message.gateway';
import {TypeOrmModule} from "@nestjs/typeorm";
import {MessageRepository} from "./message.repository";
import { MessageController } from "./message.controller";
import { JwtModule } from "@nestjs/jwt";
import JwtConfigService from "src/core/jwt/jwt-config.service";
import { UsersRepository } from "../users/user.repository";
import JwtHelper from "src/core/jwt/jwt.helper";
import { DoSpacesService } from "../SpacesModule/SpacesService/doSpacesService";
import { DoSpacesServicerovider } from "../SpacesModule/SpacesService";
import { FileUploadsService } from "../file-uploads/file-uploads.service";

@Module({
    controllers: [MessageController],
    imports: [
        JwtModule.registerAsync({ useClass: JwtConfigService }),
        TypeOrmModule.forFeature([MessageRepository, UsersRepository])
    ],
    providers: [MessageGateway, MessageService, JwtHelper, DoSpacesServicerovider, DoSpacesService, FileUploadsService]
})
export class MessageModule {
}
